// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRAuto.pas' rev: 3.00

#ifndef SMRAutoHPP
#define SMRAutoHPP
#include <SMPrntr.hpp>
#include <Grids.hpp>
#include <SMRTypes.hpp>
#include <PrintSM.hpp>
#include <Db.hpp>
#include <DBGrids.hpp>
#include <Dialogs.hpp>
#include <SysUtils.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smrauto
{
//-- type declarations -------------------------------------------------------
enum TImageAlign { iaTopPage, iaBottomPage, iaWholePage };

enum TBevels { bvNone, bvTopLine, bvBottomLine, bvLeftLine, bvRightLine, bvHCenterLine, bvVCenterLine, 
	bvFrame };

class DELPHICLASS TSMAutoPrint;
class PASCALIMPLEMENTATION TSMAutoPrint : public Printsm::TSMPrintComponent 
{
	typedef Printsm::TSMPrintComponent inherited;
	
private:
	Classes::TStrings* FHeader;
	Graphics::TFont* FHeaderFont;
	Classes::TStrings* FFooter;
	Graphics::TFont* FFooterFont;
	bool FWordWrap;
	char FMacroChar;
	void __fastcall SetMacroChar(char Value);
	bool __fastcall EvaluateMacro(System::AnsiString &strSource, Classes::TAlignment &FstrAlign, TBevels 
		&bv, System::AnsiString &ImageFile, TImageAlign &ifAlign, bool IsPage);
	void __fastcall PrintBevel(TBevels bvlLine, int X1, int Y1, int X2, int Y2);
	void __fastcall SetHeader(Classes::TStrings* Value);
	void __fastcall SetHeaderFont(Graphics::TFont* Value);
	void __fastcall SetFooter(Classes::TStrings* Value);
	void __fastcall SetFooterFont(Graphics::TFont* Value);
	
protected:
	bool boolNeedPrintHeaderGrid;
	int __fastcall PrintStrings(Classes::TStrings* strList, Graphics::TFont* fontForPrint, bool boolCalc
		, bool IsPage);
	
public:
	__fastcall virtual TSMAutoPrint(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMAutoPrint(void);
	virtual void __fastcall NewPage(bool isNewBar);
	
__published:
	__property char MacroChar = {read=FMacroChar, write=SetMacroChar, nodefault};
	__property bool WordWrap = {read=FWordWrap, write=FWordWrap, nodefault};
	__property Classes::TStrings* Header = {read=FHeader, write=SetHeader};
	__property Graphics::TFont* HeaderFont = {read=FHeaderFont, write=SetHeaderFont};
	__property Classes::TStrings* Footer = {read=FFooter, write=SetFooter};
	__property Graphics::TFont* FooterFont = {read=FFooterFont, write=SetFooterFont};
	__property AnimatedStatus ;
	__property Frame ;
	__property PrinterSetting ;
};

class DELPHICLASS TSMRACalculation;
class PASCALIMPLEMENTATION TSMRACalculation : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::Variant PrevValue;
	System::Variant CurValue;
	System::AnsiString FFieldName;
	Smrtypes::TSMRCalculation* FCalculation;
	Graphics::TFont* FFont;
	TAlignment FAlignment;
	bool FWordWrap;
	int FFieldColNum;
	System::AnsiString FCaption;
	int FCaptionColNum;
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall SetCalculation(Smrtypes::TSMRCalculation* Value);
	
public:
	__fastcall virtual TSMRACalculation(Classes::TCollection* Collection);
	__fastcall virtual ~TSMRACalculation(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall ValueChanged(void);
	
__published:
	__property System::AnsiString FieldName = {read=FFieldName, write=FFieldName};
	__property Smrtypes::TSMRCalculation* Calculation = {read=FCalculation, write=SetCalculation};
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property System::AnsiString Caption = {read=FCaption, write=FCaption};
	__property int FieldColNum = {read=FFieldColNum, write=FFieldColNum, nodefault};
	__property int CaptionColNum = {read=FCaptionColNum, write=FCaptionColNum, nodefault};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, nodefault};
	__property bool WordWrap = {read=FWordWrap, write=FWordWrap, nodefault};
};

typedef System::TMetaClass*TSMRACalculationClass;

class DELPHICLASS TSMRACalculations;
class DELPHICLASS TSMPrintData;
enum TPrintRecNo { rnNone, rnFirstCol, rnFirstColOnEachBar };

enum TColumnSource { csDBGrid, csDataSet };

class DELPHICLASS TSMRAGroup;
class PASCALIMPLEMENTATION TSMPrintData : public Smrauto::TSMAutoPrint 
{
	typedef Smrauto::TSMAutoPrint inherited;
	
private:
	int FRecNo;
	int FGapHorizontal;
	int FGapVertical;
	Dbgrids::TDBGrid* FDBGrid;
	Db::TDataSet* FDataSet;
	bool FSelectedRecord;
	TPrintRecNo FPrintRecNo;
	bool FAutoFit;
	TColumnSource FColumnSource;
	Classes::TList* FPosition;
	bool FWordWrapHeader;
	bool FBlankIfZero;
	TSMRACalculations* FCalculations;
	Classes::TList* Groups;
	int intStartColumn;
	int intEndColumn;
	int intMaxPageWidth;
	void __fastcall ReadCalculations(Classes::TReader* Reader);
	void __fastcall WriteCalculations(Classes::TWriter* Writer);
	void __fastcall SetCalculations(TSMRACalculations* Value);
	Dbgrids::TDBGrid* __fastcall GetDBGrid(void);
	void __fastcall SetDBGrid(Dbgrids::TDBGrid* AValue);
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	bool __fastcall PrintableField(Db::TField* Field);
	double __fastcall GetAutoFitCoef(void);
	int __fastcall GetMaxSize(bool boolWH, bool IsRecord, int intStart, int intEnd);
	int __fastcall GetMaxColumn(int intStart, int intPageWidth);
	void __fastcall FillColumnInfo(void);
	int __fastcall PrintHeaderGrid(int intMaxWidth);
	int __fastcall PrintRecord(int intMaxWidth, int intMaxHeight);
	int __fastcall GetGroupsMaxSize(void);
	int __fastcall PrintGroups(Db::TDataSet* ds, int intMaxWidth, int intMaxHeight);
	void __fastcall ClearGroups(void);
	void __fastcall AddGroup(TSMRACalculation* calc);
	void __fastcall FillGroups(void);
	TSMRAGroup* __fastcall GetGroup(System::AnsiString FieldName);
	bool __fastcall UpdateGroupValue(Db::TDataSet* ds, bool IsHeader);
	void __fastcall ResetGroupValue(void);
	void __fastcall ResetPrintedValues(Smrtypes::TResetType RType, System::AnsiString strGroupName);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	System::AnsiString __fastcall GetFieldStr(Db::TField* curField);
	virtual void __fastcall PrepareReport(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	DYNAMIC TSMRACalculations* __fastcall CreateCalculations(void);
	
public:
	__fastcall virtual TSMPrintData(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintData(void);
	virtual void __fastcall NewPage(bool isNewBar);
	
__published:
	__property TSMRACalculations* Calculations = {read=FCalculations, write=SetCalculations};
	__property bool BlankIfZero = {read=FBlankIfZero, write=FBlankIfZero, nodefault};
	__property int GapHorizontal = {read=FGapHorizontal, write=FGapHorizontal, nodefault};
	__property int GapVertical = {read=FGapVertical, write=FGapVertical, nodefault};
	__property Dbgrids::TDBGrid* DBGrid = {read=GetDBGrid, write=SetDBGrid};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property bool SelectedRecord = {read=FSelectedRecord, write=FSelectedRecord, nodefault};
	__property TPrintRecNo PrintRecNo = {read=FPrintRecNo, write=FPrintRecNo, nodefault};
	__property bool AutoFit = {read=FAutoFit, write=FAutoFit, nodefault};
	__property TColumnSource ColumnSource = {read=FColumnSource, write=FColumnSource, nodefault};
	__property bool WordWrapHeader = {read=FWordWrapHeader, write=FWordWrapHeader, nodefault};
	__property Font ;
};

class PASCALIMPLEMENTATION TSMRACalculations : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TSMPrintData* FSMAReport;
	TSMRACalculation* __fastcall GetCalculation(int Index);
	void __fastcall SetCalculation(int Index, TSMRACalculation* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMRACalculations(TSMPrintData* SMRA, System::TMetaClass* CalculationClass);
	HIDESBASE TSMRACalculation* __fastcall Add(void);
	void __fastcall LoadFromFile(const System::AnsiString FileName);
	void __fastcall LoadFromStream(Classes::TStream* S);
	void __fastcall SaveToFile(const System::AnsiString FileName);
	void __fastcall SaveToStream(Classes::TStream* S);
	__property TSMPrintData* SMAReport = {read=FSMAReport};
	__property TSMRACalculation* Items[int Index] = {read=GetCalculation, write=SetCalculation/*, default
		*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TSMRACalculations(void) { }
	
};

class DELPHICLASS TColumnInfo;
class PASCALIMPLEMENTATION TColumnInfo : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	System::AnsiString FieldName;
	System::AnsiString Caption;
	TAlignment Alignment;
	TAlignment HeaderAlignment;
	int Position;
	int Width;
	bool WordWrap;
	bool IsFixed;
public:
	/* TObject.Create */ __fastcall TColumnInfo(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TColumnInfo(void) { }
	
};

class PASCALIMPLEMENTATION TSMRAGroup : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	System::AnsiString FieldsList;
	System::Variant PrevValue;
	System::Variant CurValue;
	bool __fastcall ValueChanged(void);
public:
	/* TObject.Create */ __fastcall TSMRAGroup(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TSMRAGroup(void) { }
	
};

class DELPHICLASS TSMPrintStringGrid;
class PASCALIMPLEMENTATION TSMPrintStringGrid : public Smrauto::TSMAutoPrint 
{
	typedef Smrauto::TSMAutoPrint inherited;
	
private:
	int FGapHorizontal;
	int FGapVertical;
	Grids::TStringGrid* FStringGrid;
	bool FAutoFit;
	Classes::TList* FPosition;
	int intStartColumn;
	int intEndColumn;
	int intMaxPageWidth;
	double __fastcall GetAutoFitCoef(void);
	int __fastcall GetMaxSize(bool boolWH, int intRow, int intStart, int intEnd);
	int __fastcall GetMaxColumn(int intStart, int intPageWidth);
	void __fastcall FillColumnInfo(void);
	int __fastcall PrintHeaderGrid(int intMaxWidth);
	int __fastcall PrintRow(int intRow, int intMaxWidth, int intMaxHeight);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall PrepareReport(void);
	
public:
	__fastcall virtual TSMPrintStringGrid(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintStringGrid(void);
	
__published:
	__property int GapHorizontal = {read=FGapHorizontal, write=FGapHorizontal, nodefault};
	__property int GapVertical = {read=FGapVertical, write=FGapVertical, nodefault};
	__property Grids::TStringGrid* StringGrid = {read=FStringGrid, write=FStringGrid};
	__property bool AutoFit = {read=FAutoFit, write=FAutoFit, nodefault};
};

enum TCodePage { cpANSI, cpASCII };

class DELPHICLASS TSMPrintText;
class PASCALIMPLEMENTATION TSMPrintText : public Smrauto::TSMAutoPrint 
{
	typedef Smrauto::TSMAutoPrint inherited;
	
private:
	TCodePage FCodePage;
	System::AnsiString FFileName;
	int __fastcall PrintLine(System::AnsiString strForPrint, int intMaxWidth);
	int __fastcall GetStartChar(System::AnsiString str, int intMaxWidth);
	
protected:
	virtual void __fastcall PrepareReport(void);
	
public:
	__fastcall virtual TSMPrintText(Classes::TComponent* AOwner);
	
__published:
	__property TCodePage CodePage = {read=FCodePage, write=FCodePage, nodefault};
	__property System::AnsiString FileName = {read=FFileName, write=FFileName};
	__property Font ;
public:
	/* TSMAutoPrint.Destroy */ __fastcall virtual ~TSMPrintText(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int AlignFlags[3];
extern PACKAGE Word WordWraps[2];

}	/* namespace Smrauto */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrauto;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMRAuto
