// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRBase.pas' rev: 3.00

#ifndef SMRBaseHPP
#define SMRBaseHPP
#include <SMPrntr.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <SMRPars.hpp>
#include <SMRTypes.hpp>
#include <SMExpr.hpp>
#include <SMPWhen.hpp>
#include <PrintSM.hpp>
#include <SMRCnst.hpp>
#include <Db.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smrbase
{
//-- type declarations -------------------------------------------------------
struct TDesignerOptions
{
	bool DisplayGrid;
	bool SnapToGrid;
	int GridSizeX;
	int GridSizeY;
	bool ShowBandTitle;
	int curPalette;
	bool Flat;
} ;

enum TSMRControlResize { scrLeftTop, scrTop, scrRightTop, scrLeft, scrRight, scrLeftBottom, scrBottom, 
	scrRightBottom, scrNone };

enum TSMRControlState { scsNothing, scsResize, scsMove };

enum TSMRObjectPosition { opDesigned, opTopBand, opBottomBand, opCenterBand };

typedef System::TMetaClass*TSMRControlClass;

class DELPHICLASS TSMRControl;
class DELPHICLASS TSMReport;
typedef void __fastcall (__closure *TColumnEvent)(System::TObject* Sender, int Column);

enum TUpdateValue { uvAllBand, uvWithoutGroupFooter, uvOnlyGroupFooter };

enum TSMReportState { rsNone, rsDesign, rsPrepare, rsPrint };

class DELPHICLASS TSMRBand;
enum TBandType { btNone, btReportTitle, btPageHeader, btColumnHeader, btGroupHeader, btDetail, btGroupFooter, 
	btColumnFooter, btPageFooter, btReportSummary };

class PASCALIMPLEMENTATION TSMReport : public Printsm::TSMPrintComponent 
{
	typedef Printsm::TSMPrintComponent inherited;
	
private:
	Db::TDataSet* FDataSet;
	int intBarWidth;
	int intColumnLeft;
	int intColumnTop;
	int intColumnBottom;
	bool boolWasNewPage;
	int FStartAt;
	int FCountBy;
	int FBarNumber;
	int FColumnSpace;
	int FColumnNumber;
	TColumnEvent FBeginColumn;
	TColumnEvent FEndColumn;
	Smrpars::TGetVariableEvent FGetVariableEvent;
	void __fastcall FillDSList(void);
	void __fastcall ResetPrintedValues(Smrtypes::TResetType RType, System::AnsiString strGroupName);
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	System::Variant __fastcall GetSysDataValue(Smrcnst::TSMRSysDataType sdType);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	DYNAMIC Classes::TComponent* __fastcall GetChildParent(void);
	DYNAMIC Classes::TComponent* __fastcall GetChildOwner(void);
	System::AnsiString __fastcall GetUniqueName(System::AnsiString sName);
	void __fastcall UpdateCurValues(TUpdateValue UpdateValues);
	virtual void __fastcall PrepareReport(void);
	void __fastcall SMRGetVariable(System::TObject* Sender, System::AnsiString VariableName, bool &Accept
		, Db::TFieldType &VariableType, System::Variant &Value);
	
public:
	TSMReportState ReportState;
	Classes::TList* Bands;
	Classes::TList* DataSets;
	int intCurColumn;
	__fastcall virtual TSMReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMReport(void);
	void __fastcall DesignReport(void);
	void __fastcall NewReport(void);
	void __fastcall SaveReport(System::AnsiString FFileName);
	void __fastcall LoadReport(System::AnsiString FFileName);
	int __fastcall AppendBand(TSMRBand* band, bool boolAppend);
	int __fastcall AddBand(TBandType bt, bool boolAppend);
	void __fastcall DeleteBand(int i);
	void __fastcall DeleteAllBands(void);
	void __fastcall AddGroup(int &intGroupHeader, int &intGroupFooter, bool boolNewPage, bool boolReprintHeader
		, double flLessThan, System::AnsiString strExpression);
	void __fastcall DeleteGroup(System::AnsiString strExpression);
	int __fastcall GetIndexBand(TBandType bt);
	TSMRBand* __fastcall GetBand(int i);
	TSMRControl* __fastcall GetFirstSelected(void);
	void __fastcall SelectElements(int Select);
	void __fastcall AssignGroups(bool boolClear, Classes::TStrings* sl);
	void __fastcall AssignDataSets(Classes::TStrings* sl);
	virtual void __fastcall NewPage(bool isNewBar);
	
__published:
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property int BarNumber = {read=FBarNumber, write=FBarNumber, nodefault};
	__property int ColumnSpace = {read=FColumnSpace, write=FColumnSpace, nodefault};
	__property int ColumnNumber = {read=FColumnNumber, write=FColumnNumber, nodefault};
	__property int PageNoStartAt = {read=FStartAt, write=FStartAt, nodefault};
	__property int PageNoCountBy = {read=FCountBy, write=FCountBy, nodefault};
	__property TColumnEvent OnBeginColumn = {read=FBeginColumn, write=FBeginColumn};
	__property TColumnEvent OnEndColumn = {read=FEndColumn, write=FEndColumn};
	__property AnimatedStatus ;
	__property Frame ;
	__property PrinterSetting ;
	__property Font ;
	__property Smrpars::TGetVariableEvent GetVariableEvent = {read=FGetVariableEvent, write=FGetVariableEvent
		};
};

class PASCALIMPLEMENTATION TSMRControl : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	System::Variant FPrevValue;
	System::Variant FCurValue;
	TSMRControlResize FSMRControlResize;
	TSMRControlState FSMRControlState;
	Smpwhen::TSMPrintWhen FSMPrintWhen;
	System::AnsiString FDisplayName;
	bool FSelected;
	TAlignment FAlignment;
	Printsm::TSMRFrame* FFrame;
	TBrushStyle FBrushStyle;
	Classes::TStrings* FComments;
	TSMRObjectPosition FObjectPosition;
	Graphics::TColor FBackColor;
	int FStartMouseDownX;
	int FStartMouseDownY;
	System::Variant __fastcall GetPrevValue(void);
	System::Variant __fastcall GetCurValue(void);
	bool __fastcall ValueChanged(void);
	bool __fastcall GetTransparent(void);
	void __fastcall SetTransparent(bool Value);
	void __fastcall SetSelected(bool Value);
	void __fastcall SetFrame(Printsm::TSMRFrame* Value);
	void __fastcall SetDisplayName(System::AnsiString Value);
	void __fastcall SetComments(Classes::TStrings* Value);
	void __fastcall DrawDefault(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect);
	void __fastcall DrawPoint(Graphics::TCanvas* ACanvas, int X, int Y);
	void __fastcall DrawSelection(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect);
	int __fastcall DrawWrapText(Graphics::TCanvas* ACanvas, System::AnsiString Text, const Windows::TRect 
		&ARect, Word Flags, int AAngle);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall SetAlignment(Classes::TAlignment Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	TSMReport* FSMReport;
	__fastcall virtual TSMRControl(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRControl(void);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	void __fastcall EditSizes(void);
	__property Smpwhen::TSMPrintWhen SMPrintWhen = {read=FSMPrintWhen, write=FSMPrintWhen};
	__property bool Selected = {read=FSelected, write=SetSelected, nodefault};
	__property System::Variant PrevValue = {read=GetPrevValue, write=FPrevValue};
	__property System::Variant CurValue = {read=GetCurValue, write=FCurValue};
	
__published:
	__property System::AnsiString DisplayName = {read=FDisplayName, write=SetDisplayName};
	__property Printsm::TSMRFrame* Frame = {read=FFrame, write=SetFrame};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, nodefault};
	__property bool Transparent = {read=GetTransparent, write=SetTransparent, nodefault};
	__property Graphics::TBrushStyle BrushStyle = {read=FBrushStyle, write=FBrushStyle, nodefault};
	__property Classes::TStrings* Comments = {read=FComments, write=SetComments};
	__property TSMRObjectPosition ObjectPosition = {read=FObjectPosition, write=FObjectPosition, nodefault
		};
	__property Graphics::TColor BackColor = {read=FBackColor, write=FBackColor, nodefault};
	__property Height ;
	__property Width ;
	__property Left ;
	__property Top ;
	__property Font ;
};

class DELPHICLASS TSMRLabel;
class PASCALIMPLEMENTATION TSMRLabel : public Smrbase::TSMRControl 
{
	typedef Smrbase::TSMRControl inherited;
	
private:
	bool FWordWrap;
	int FAngle;
	bool FStretch;
	void __fastcall SetAngle(int Value);
	int __fastcall DoDrawText(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect, Word Flags, System::AnsiString 
		Text);
	
protected:
	virtual System::AnsiString __fastcall GetValueForShow(const System::Variant &Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	__fastcall virtual TSMRLabel(Classes::TComponent* AOwner);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property int Angle = {read=FAngle, write=SetAngle, nodefault};
	__property bool WordWrap = {read=FWordWrap, write=FWordWrap, nodefault};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
public:
	/* TSMRControl.Destroy */ __fastcall virtual ~TSMRLabel(void) { }
	
};

class DELPHICLASS TSMRExpression;
class PASCALIMPLEMENTATION TSMRExpression : public Smrbase::TSMRLabel 
{
	typedef Smrbase::TSMRLabel inherited;
	
private:
	System::AnsiString FExpression;
	System::AnsiString FFormat;
	Smrtypes::TSMRCalculation* FCalculation;
	void __fastcall SetCalculation(Smrtypes::TSMRCalculation* Value);
	
protected:
	virtual System::AnsiString __fastcall GetValueForShow(const System::Variant &Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	__fastcall virtual TSMRExpression(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRExpression(void);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property System::AnsiString Expression = {read=FExpression, write=FExpression};
	__property System::AnsiString Format = {read=FFormat, write=FFormat};
	__property Smrtypes::TSMRCalculation* Calculation = {read=FCalculation, write=SetCalculation};
};

class DELPHICLASS TSMRSysData;
class PASCALIMPLEMENTATION TSMRSysData : public Smrbase::TSMRLabel 
{
	typedef Smrbase::TSMRLabel inherited;
	
private:
	TSMRSysDataType FSysData;
	System::AnsiString FFormat;
	void __fastcall SetSysData(Smrcnst::TSMRSysDataType Value);
	
protected:
	virtual System::AnsiString __fastcall GetValueForShow(const System::Variant &Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	__fastcall virtual TSMRSysData(Classes::TComponent* AOwner);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property Smrcnst::TSMRSysDataType SysData = {read=FSysData, write=SetSysData, nodefault};
	__property System::AnsiString Format = {read=FFormat, write=FFormat};
public:
	/* TSMRControl.Destroy */ __fastcall virtual ~TSMRSysData(void) { }
	
};

enum TShapeStretch { ssNoStretch, ssTallest, ssHeight };

enum TShapeType { stLine, stRectangle, stEllipse };

enum TLineType { ltTop, ltBottom, ltLeft, ltRight, ltLeftDiagonal, ltRightDiagonal, ltHCenter, ltVCenter 
	};

enum TRectangleType { rtRectangle, rtRoundRect, rtSquare, rtRoundSquare };

enum TEllipseType { etEllipse, etCircle };

class DELPHICLASS TSMRShape;
class PASCALIMPLEMENTATION TSMRShape : public Smrbase::TSMRControl 
{
	typedef Smrbase::TSMRControl inherited;
	
private:
	TShapeStretch FStretch;
	TLineType FLineType;
	TRectangleType FRectangleType;
	TEllipseType FEllipseType;
	void __fastcall DrawLine(Graphics::TCanvas* ACanvas, const Windows::TRect &BRect);
	
protected:
	TShapeType ShapeType;
	__property TLineType LineType = {read=FLineType, write=FLineType, nodefault};
	__property TRectangleType RectangleType = {read=FRectangleType, write=FRectangleType, nodefault};
	__property TEllipseType EllipseType = {read=FEllipseType, write=FEllipseType, nodefault};
	
public:
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property TShapeStretch Stretch = {read=FStretch, write=FStretch, nodefault};
public:
	/* TSMRControl.Create */ __fastcall virtual TSMRShape(Classes::TComponent* AOwner) : Smrbase::TSMRControl(
		AOwner) { }
	/* TSMRControl.Destroy */ __fastcall virtual ~TSMRShape(void) { }
	
};

class DELPHICLASS TSMRLine;
class PASCALIMPLEMENTATION TSMRLine : public Smrbase::TSMRShape 
{
	typedef Smrbase::TSMRShape inherited;
	
public:
	__fastcall virtual TSMRLine(Classes::TComponent* AOwner);
	
__published:
	__property LineType ;
public:
	/* TSMRControl.Destroy */ __fastcall virtual ~TSMRLine(void) { }
	
};

class DELPHICLASS TSMRRectangle;
class PASCALIMPLEMENTATION TSMRRectangle : public Smrbase::TSMRShape 
{
	typedef Smrbase::TSMRShape inherited;
	
public:
	__fastcall virtual TSMRRectangle(Classes::TComponent* AOwner);
	
__published:
	__property RectangleType ;
public:
	/* TSMRControl.Destroy */ __fastcall virtual ~TSMRRectangle(void) { }
	
};

class DELPHICLASS TSMREllipse;
class PASCALIMPLEMENTATION TSMREllipse : public Smrbase::TSMRShape 
{
	typedef Smrbase::TSMRShape inherited;
	
public:
	__fastcall virtual TSMREllipse(Classes::TComponent* AOwner);
	
__published:
	__property EllipseType ;
public:
	/* TSMRControl.Destroy */ __fastcall virtual ~TSMREllipse(void) { }
	
};

class DELPHICLASS TSMRImage;
class PASCALIMPLEMENTATION TSMRImage : public Smrbase::TSMRControl 
{
	typedef Smrbase::TSMRControl inherited;
	
private:
	System::AnsiString FExpression;
	Graphics::TPicture* FPicture;
	System::AnsiString FFileName;
	bool FStretch;
	bool FCenter;
	
public:
	__fastcall virtual TSMRImage(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRImage(void);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property System::AnsiString FileName = {read=FFileName, write=FFileName};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
	__property bool Center = {read=FCenter, write=FCenter, nodefault};
	__property System::AnsiString Expression = {read=FExpression, write=FExpression};
};

class DELPHICLASS TSMRichText;
class PASCALIMPLEMENTATION TSMRichText : public Smrbase::TSMRControl 
{
	typedef Smrbase::TSMRControl inherited;
	
private:
	System::AnsiString FExpression;
	Comctrls::TRichEdit* FRichEdit;
	System::AnsiString FFileName;
	bool FStretch;
	
public:
	__fastcall virtual TSMRichText(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRichText(void);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual void __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property System::AnsiString FileName = {read=FFileName, write=FFileName};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
	__property System::AnsiString Expression = {read=FExpression, write=FExpression};
};

class PASCALIMPLEMENTATION TSMRBand : public Smrbase::TSMRControl 
{
	typedef Smrbase::TSMRControl inherited;
	
private:
	int X1;
	int Y1;
	int X2;
	int Y2;
	int FLinkedBand;
	TBandType FBandType;
	bool FStretch;
	bool FNewPage;
	bool FReprintHeader;
	double FLessThan;
	System::AnsiString FExpression;
	bool __fastcall GetIsGroup(void);
	System::TMetaClass* __fastcall GetClassByName(System::AnsiString strClassName);
	
protected:
	void __fastcall BandDragDropEvent(System::TObject* Sender, System::TObject* Source, int X, int Y);
	void __fastcall BandDragOverEvent(System::TObject* Sender, System::TObject* Source, int X, int Y, Controls::TDragState 
		State, bool &Accept);
	virtual void __fastcall Paint(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	int __fastcall PrintBand(int intShift, int intBottom, Word Flags);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	DYNAMIC Classes::TComponent* __fastcall GetChildParent(void);
	DYNAMIC Classes::TComponent* __fastcall GetChildOwner(void);
	
public:
	Classes::TList* Objects;
	__fastcall virtual TSMRBand(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRBand(void);
	int __fastcall AddElement(System::TMetaClass* cntrlClass);
	int __fastcall GetElement(TSMRControl* smrControl);
	void __fastcall DeleteAllElements(void);
	void __fastcall ChangeOrder(bool BringToFront);
	System::AnsiString __fastcall GetBandName(void);
	__property OnMouseMove ;
	
__published:
	__property bool IsGroup = {read=GetIsGroup, nodefault};
	__property int LinkedBand = {read=FLinkedBand, write=FLinkedBand, nodefault};
	__property TBandType BandType = {read=FBandType, write=FBandType, nodefault};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
	__property bool NewPage = {read=FNewPage, write=FNewPage, nodefault};
	__property bool ReprintHeader = {read=FReprintHeader, write=FReprintHeader, nodefault};
	__property double LessThan = {read=FLessThan, write=FLessThan};
	__property System::AnsiString Expression = {read=FExpression, write=FExpression};
};

class DELPHICLASS TSMRRegisterControl;
class PASCALIMPLEMENTATION TSMRRegisterControl : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	int HintIndex;
	System::AnsiString Hint;
	int hInstance;
	int intCursorIndex;
public:
	/* TObject.Create */ __fastcall TSMRRegisterControl(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TSMRRegisterControl(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define intPointHeight (Byte)(5)
extern PACKAGE TDesignerOptions DesignerOptions;
extern PACKAGE Classes::TStringList* lstSMRControls;
extern PACKAGE Menus::TPopupMenu* pmSMRControl;
extern PACKAGE int __fastcall GetUnsignedCursor(void);
extern PACKAGE void __fastcall RegisterSMRControl(System::TMetaClass* ASMRControlClass, int AHintIndex
	, System::AnsiString AHint, int AHInstance);
extern PACKAGE void __fastcall UnRegisterSMRControl(System::TMetaClass* ASMRControlClass);

}	/* namespace Smrbase */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrbase;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMRBase
